#include <Windows.h>
#include "GetTickCount_ms.h"

LARGE_INTEGER pFrequency = {0};


/** The standard Windows function GetTickCount() has granularity 15ms.
 * It is not good enough for fast processes. */
unsigned GetTickCount_ms(void)
{
LARGE_INTEGER CurrentTime;

  if(pFrequency.QuadPart==0)
    if(QueryPerformanceFrequency(&pFrequency)==0)
      pFrequency.QuadPart = 1;

  if(pFrequency.QuadPart <= 1) return GetTickCount();

  QueryPerformanceCounter(&CurrentTime);
  return (1000*CurrentTime.QuadPart) / pFrequency.QuadPart;
}